# Rendering

## RecipeSet Render

<mark style="color:blue;">`GET`</mark> `https://api.spectrumcustomizer.com/api/assets/generated/recipeset/readable/:readableId/:viewAngleHandle`

This endpoint allows you to render all items within a RecipeSet at the predefined view angle.

#### Path Parameters

| Name            | Type   | Description                                                                                                 |
| --------------- | ------ | ----------------------------------------------------------------------------------------------------------- |
| viewAngleHandle | string | Handle for the angle of the product to display.  (e.g. "north", "south", "east", "west", "northeast", etc.) |
| readableId      | string | 8 digit alphanumeric RecipeSet readable identifier.                                                         |

{% tabs %}
{% tab title="200 Direct image download of byte array with appropriate content type.  Spectrum will return an image directly when transformations are applied.  See: Image Transformations in API section." %}

```
HTTP/1.1 200 OK
Cache-Control: no-cache
Pragma: no-cache
Content-Length: 215919
Content-Type: image/png
Expires: -1
Server: Microsoft-IIS/10.0
X-AspNet-Version: 4.0.30319
Request-Context: appId=cid-v1:3563b4f7-e3dc-42cf-9689-3d04e3f8ace6
Access-Control-Expose-Headers: Request-Context
X-Powered-By: ASP.NET
Date: Fri, 22 Jan 2021 21:17:42 GMT

[File Content]

```

{% endtab %}

{% tab title="301 Redirect to location of asset within Spectrum CDN with no resizing or transformations applied." %}

```
HTTP/1.1 301 Moved Permanently
Cache-Control: no-cache
Pragma: no-cache
Expires: -1
Location: https://cdn.spectrumcustomizer.com/assets/generated/recipeset/example.png
Server: Microsoft-IIS/10.0
X-AspNet-Version: 4.0.30319
Request-Context: appId=cid-v1:3563b4f7-e3dc-42cf-9689-3d04e3f8ace6
Access-Control-Expose-Headers: Request-Context
X-Powered-By: ASP.NET
Date: Fri, 22 Jan 2021 21:12:33 GMT
Content-Length: 0

```

{% endtab %}

{% tab title="404 Could not find valid RecipeSet Readable Id." %}

```
{    "message": "Unable to locate recipeSetId."}
```

{% endtab %}

{% tab title="500 Spectrum encountered an error in processing." %}

```
{"message":"An error has occurred.","exceptionMessage":"Object reference not set to an instance of an object."}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.spectrumcustomizer.com/integration/api/rendering.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
